#include "cflironecontrol.h"
//GUID 
#include <initguid.h>
DEFINE_GUID(GUID_DEVINTERFACE_FLIRONEGEN2_IAP,0x41a83025, 0x9dc8, 0x4e75, 0x87, 0x5, 0x12, 0x9, 0x22, 0x2f, 0xdc, 0x17);
DEFINE_GUID(GUID_DEVINTERFACE_FLIRONEGEN2_FRAME,0x1b2e6756, 0x344, 0x449e, 0x8b, 0x5b, 0xbd, 0x57, 0xf5, 0x82, 0x76, 0x6b);
DEFINE_GUID(GUID_DEVINTERFACE_FLIRONEGEN2_FILEIO,0xaa0dfc0c, 0xe043, 0x4778, 0x9d, 0xba, 0x28, 0x74, 0x9a, 0x3a, 0xa9, 0xf5);

//- --------------------------------------------------------
CFlirOneControl::CFlirOneControl(void)
{ 
 SizeOfData=1048576;
 Data=new char[SizeOfData]; 

 ImageBuffer=new unsigned char[IMAGE_BUFFER_SIZE];
 ImageBufferSize=0;
 ImageIndex=0;

 for(long n=0;n<256;n++)
 {
 ColorMap_R[n]=(unsigned char)n;
 ColorMap_G[n]=(unsigned char)n;
 ColorMap_B[n]=(unsigned char)n;
 } 

 hFile_FileIO=INVALID_HANDLE_VALUE;
 hFile_Frame=INVALID_HANDLE_VALUE;
 hFile_iAP=INVALID_HANDLE_VALUE;


 Overlapped_Frame.Internal=0;
 Overlapped_Frame.InternalHigh=0;
 Overlapped_Frame.Offset=0;
 Overlapped_Frame.OffsetHigh=0;
 Overlapped_Frame.hEvent=CreateEvent(NULL,TRUE,FALSE,NULL);

 Overlapped_FileIO.Internal=0;
 Overlapped_FileIO.InternalHigh=0;
 Overlapped_FileIO.Offset=0;
 Overlapped_FileIO.OffsetHigh=0;
 Overlapped_FileIO.hEvent=CreateEvent(NULL,TRUE,FALSE,NULL);

 Overlapped_iAP.Internal=0;
 Overlapped_iAP.InternalHigh=0;
 Overlapped_iAP.Offset=0;
 Overlapped_iAP.OffsetHigh=0;
 Overlapped_iAP.hEvent=CreateEvent(NULL,TRUE,FALSE,NULL);

 Start_FileIO=false;
 Start_Frame=false;
 Start_iAP=false;
}
//- ---------------------------------------------------------
CFlirOneControl::~CFlirOneControl()
{
 DeleteObject(Overlapped_Frame.hEvent);
 DeleteObject(Overlapped_FileIO.hEvent);
 DeleteObject(Overlapped_iAP.hEvent);
 delete[](Data);
 delete[](ImageBuffer);
 Close();
}
//- ------------------------------------------------------------

//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::Open(void)
{
 Close();
 AddLog("Open!\r\n");
 char completeDeviceName_iAP[MAX_DEVPATH_LENGTH];
 char completeDeviceName_Frame[MAX_DEVPATH_LENGTH];
 char completeDeviceName_FileIO[MAX_DEVPATH_LENGTH];
 if (GetDevicePath((LPGUID)&GUID_DEVINTERFACE_FLIRONEGEN2_IAP,completeDeviceName_iAP,sizeof(completeDeviceName_iAP))==false)//     
 {
  AddLog("[]    iAP  GUID!\r\n");
  return(false);
 }
 if (GetDevicePath((LPGUID)&GUID_DEVINTERFACE_FLIRONEGEN2_FRAME,completeDeviceName_Frame,sizeof(completeDeviceName_Frame))==false)//     
 {
  AddLog("[]    Frame  GUID!\r\n");
  return(false);
 }
 if (GetDevicePath((LPGUID)&GUID_DEVINTERFACE_FLIRONEGEN2_FILEIO,completeDeviceName_FileIO,sizeof(completeDeviceName_FileIO))==false)//     
 {
  AddLog("[]    Frame  GUID!\r\n");
  return(false);
 }
 AddLog("iAP: ");
 AddLog(completeDeviceName_iAP);
 AddLog("\r\n");
 AddLog("Frame: ");
 AddLog(completeDeviceName_Frame);
 AddLog("\r\n");
 AddLog("FileIO: ");
 AddLog(completeDeviceName_FileIO);
 AddLog("\r\n");
 //  
 hFile_iAP=CreateFile(completeDeviceName_iAP,GENERIC_WRITE|GENERIC_READ,FILE_SHARE_WRITE|FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

// hFile_Frame=CreateFile("D:\\FlirOneControl\\Release\\data-linux.txt",GENERIC_READ,FILE_SHARE_WRITE|FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED,NULL);



 hFile_Frame=CreateFile(completeDeviceName_Frame,GENERIC_WRITE|GENERIC_READ,FILE_SHARE_WRITE|FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 hFile_FileIO=CreateFile(completeDeviceName_FileIO,GENERIC_WRITE|GENERIC_READ,FILE_SHARE_WRITE|FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

 if (hFile_iAP==INVALID_HANDLE_VALUE)
 {
  AddLog("[]    iAP!\r\n");
  Close();
  return(false);
 }
 if (hFile_Frame==INVALID_HANDLE_VALUE)
 {
 AddLog("[]    Frame!\r\n");
 Close();
 return(false);
 }
 if (hFile_FileIO==INVALID_HANDLE_VALUE)
 {
 AddLog("[]    FileIO!\r\n");
 Close();
 return(false);
 }
 //   
 CEvent cEvent_Pause;
 cEvent_Pause.ResetEvent();
 long size;
 long nBytes;
 char buffer[256];
 size=sizeof(buffer);  
 if (DeviceIoControl(hFile_iAP,IOCTL_FLIR_ONE_GEN2_FILEIO_STOP,buffer,size,buffer,size,(PULONG)&nBytes,NULL)==FALSE)
 {
  AddLog("[]   IOCTL_FLIR_ONE_GEN2_FILEIO_STOP!\r\n");
  Close();
  return(false);  
 } 
 WaitForSingleObject(cEvent_Pause.m_hObject,200);

 size=sizeof(buffer);
 if (DeviceIoControl(hFile_iAP,IOCTL_FLIR_ONE_GEN2_FRAME_STOP,buffer,size,buffer,size,(PULONG)&nBytes,NULL)==FALSE)
 {
  AddLog("[]   IOCTL_FLIR_ONE_GEN2_FRAME_STOP!\r\n");
  Close();
  return(false);  
 }
 WaitForSingleObject(cEvent_Pause.m_hObject,200);

 size=sizeof(buffer);
 if (DeviceIoControl(hFile_iAP,IOCTL_FLIR_ONE_GEN2_FILEIO_START,buffer,size,buffer,size,(PULONG)&nBytes,NULL)==FALSE)
 {
  AddLog("[]   IOCTL_FLIR_ONE_GEN2_FILEIO_START!\r\n");
  Close();
  return(false);  
 }
 WaitForSingleObject(cEvent_Pause.m_hObject,200);

 size=sizeof(buffer);
 if (DeviceIoControl(hFile_iAP,IOCTL_FLIR_ONE_GEN2_FRAME_START,buffer,size,buffer,size,(PULONG)&nBytes,NULL)==FALSE)
 {
  AddLog("[]   IOCTL_FLIR_ONE_GEN2_FRAME_START!\r\n");
  Close();
  return(false);  
 }
 WaitForSingleObject(cEvent_Pause.m_hObject,200);

 return(true);
}
//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
void CFlirOneControl::Close(void)
{
 AddLog("Close!\r\n");
 if (hFile_FileIO!=INVALID_HANDLE_VALUE)
 {
 AddLog("FileIO .\r\n");
 CloseHandle(hFile_FileIO);
 }
 if (hFile_Frame!=INVALID_HANDLE_VALUE)
 {
 AddLog("Frame .\r\n");
 CloseHandle(hFile_Frame);
 }
 if (hFile_iAP!=INVALID_HANDLE_VALUE)
 {
 AddLog("iAP .\r\n");
 CloseHandle(hFile_iAP);
 }
 hFile_FileIO=INVALID_HANDLE_VALUE;
 hFile_Frame=INVALID_HANDLE_VALUE;
 hFile_iAP=INVALID_HANDLE_VALUE;
}
//----------------------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::Processing(void)
{
 if (hFile_FileIO==INVALID_HANDLE_VALUE) return(false);
 if (hFile_Frame==INVALID_HANDLE_VALUE) return(false);
 if (hFile_iAP==INVALID_HANDLE_VALUE) return(false);
 unsigned long readen; 
 //  
 if (ReadFile(hFile_Frame,Data,512,&readen,NULL)==TRUE)
 {
  CreateImage((unsigned char*)Data,readen);
  //AddLog("Data Frame!\r\n");
 }

 /*
 if (Start_Frame==false)
 {
  if (ReadFile(hFile_Frame,Data,512,&readen,&Overlapped_Frame)==FALSE) ResetEvent(Overlapped_Frame.hEvent); 
  Start_Frame=true;
 }
 if (Start_Frame==true)
 {
  if (WaitForSingleObject(Overlapped_Frame.hEvent,0)==WAIT_OBJECT_0)// 
  {
   if (GetOverlappedResult(hFile_Frame,&Overlapped_Frame,&readen,TRUE)==TRUE)
   {
    CreateImage((unsigned char*)Data,readen);
   // AddLog("Data Frame!\r\n");
    FILE *file=fopen("data.txt","ab");
    if (file!=NULL)
    {
     fwrite(Data,1,readen,file);
     fclose(file);
    }
    Overlapped_Frame.Offset+=readen;
	Start_Frame=true;// 	
   }   
  }
 }
 */
 /*
 ReadFile(hFile_FileIO,Data,512,&readen,&Overlapped_FileIO);
 if (WaitForSingleObject(Overlapped_FileIO.hEvent,0)!=WAIT_OBJECT_0)// 
 {
  if (GetOverlappedResult(hFile_FileIO,&Overlapped_FileIO,&readen,TRUE))
  {
   AddLog("Data FileIO!\r\n");
  }
 }

 ReadFile(hFile_iAP,Data,512,&readen,&Overlapped_iAP);
 if (WaitForSingleObject(Overlapped_iAP.hEvent,0)!=WAIT_OBJECT_0)// 
 {
  if (GetOverlappedResult(hFile_iAP,&Overlapped_iAP,&readen,TRUE))
  {
   AddLog("Data iAP!\r\n");
  }
 }
 */
/*
 ReadFile(hFile_FileIO,Data,512,&readen,&Overlapped_FileIO);
 ReadFile(hFile_iAP,Data,512,&readen,&Overlapped_iAP);
 //ReadFile(hFile_FileIO,Data,512,&readen,NULL); 
 //ReadFile(hFile_iAP,Data,512,&readen,NULL);
 */
 return(true);
}


//----------------------------------------------------------------------------------------------------
//   log-
//----------------------------------------------------------------------------------------------------
void CFlirOneControl::AddLog(char *string)
{
 FILE *file=fopen("log.txt","ab");
 if (file==NULL) return;
 fprintf(file,"%s",string);
 fclose(file);
}
//----------------------------------------------------------------------------------------------------
//   log-
//----------------------------------------------------------------------------------------------------
void CFlirOneControl::AddLog(long value)
{
 FILE *file=fopen("log.txt","ab");
 if (file==NULL) return;
 fprintf(file,"%i",value);
 fclose(file);
}

//----------------------------------------------------------------------------------------------------
//   GUID
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::GetDevicePath(IN LPGUID InterfaceGuid,PCHAR DevicePath,size_t BufLen)
{
 HDEVINFO HardwareDeviceInfo;
 SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
 PSP_DEVICE_INTERFACE_DETAIL_DATA DeviceInterfaceDetailData=NULL;
 ULONG Length,RequiredLength=0;
 BOOL bResult;

 HardwareDeviceInfo=SetupDiGetClassDevs(InterfaceGuid,NULL,NULL,(DIGCF_PRESENT|DIGCF_DEVICEINTERFACE));
 if (HardwareDeviceInfo==INVALID_HANDLE_VALUE) 
 {
  AddLog("[]   SetupDiGetClassDevs!\r\n");
  return(false);
 }

 DeviceInterfaceData.cbSize=sizeof(SP_DEVICE_INTERFACE_DATA);
 bResult=SetupDiEnumDeviceInterfaces(HardwareDeviceInfo,0,InterfaceGuid,0,&DeviceInterfaceData);
 if (bResult==FALSE) 
 {
  AddLog("[]   SetupDiEnumDeviceInterfaces!\r\n");
  SetupDiDestroyDeviceInfoList(HardwareDeviceInfo);
  return(false);
 }
 SetupDiGetDeviceInterfaceDetail(HardwareDeviceInfo,&DeviceInterfaceData,NULL,0,&RequiredLength,NULL);
 DeviceInterfaceDetailData=(PSP_DEVICE_INTERFACE_DETAIL_DATA)
 LocalAlloc(LMEM_FIXED,RequiredLength);

 if (DeviceInterfaceDetailData==NULL) 
 {
  SetupDiDestroyDeviceInfoList(HardwareDeviceInfo);
  AddLog("[]   !\r\n");
  return(false);
 }
 DeviceInterfaceDetailData->cbSize=sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
 Length=RequiredLength;

 bResult=SetupDiGetDeviceInterfaceDetail(HardwareDeviceInfo,&DeviceInterfaceData,DeviceInterfaceDetailData,Length,&RequiredLength,NULL);
 if (bResult==FALSE) 
 {
  SetupDiDestroyDeviceInfoList(HardwareDeviceInfo);
  AddLog("[]   SetupDiGetDeviceInterfaceDetail!\r\n");
  return(false);
 }
 if (strlen(DeviceInterfaceDetailData->DevicePath)>=BufLen-1)
 {
  SetupDiDestroyDeviceInfoList(HardwareDeviceInfo);
  LocalFree(DeviceInterfaceDetailData);
  return(false);
 }
 strcpy(DevicePath,DeviceInterfaceDetailData->DevicePath);
 SetupDiDestroyDeviceInfoList(HardwareDeviceInfo);
 LocalFree(DeviceInterfaceDetailData);
 return(true);
}



//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::CreateImage(unsigned char *buffer,unsigned long size)
{
 unsigned long n;
 long x;
 long y;
 if (size+ImageBufferSize>=IMAGE_BUFFER_SIZE) ImageBufferSize=0;//  
 // 
 for(n=0;n<size;n++) ImageBuffer[n+ImageBufferSize]=buffer[n];
 ImageBufferSize+=size; 
 if (ImageBufferSize<4) return(false);

 //     4  ,     
 unsigned char magicbyte[4]={0xEF,0xBE,0x00,0x00};
 for(n=0;n<ImageBufferSize-4;n++)
 {
 long m;
 bool ok=true;
 for(m=0;m<4;m++)
 {
 if (ImageBuffer[n+m]==magicbyte[m]) continue;
 ok=false;
 break;
 }
 if (ok==true)// 
 {
 //   
 long size=ImageBufferSize-n-4;
 for(m=0;m<size;m++) ImageBuffer[m]=ImageBuffer[m+n+4];
 ImageBufferSize=size;
 n=0;//  
 }
 }
 if (ImageBufferSize<24) return(false);//  
 unsigned long FrameSize=*((unsigned long *)(ImageBuffer+8));
 unsigned long ThermalSize=*((unsigned long *)(ImageBuffer+12));
 unsigned long JpgSize=*((unsigned long *)(ImageBuffer+16));
 unsigned long StatusSize=*((unsigned long *)(ImageBuffer+20));
 if (FrameSize+28>ImageBufferSize) return(false);//    

 // 
 ImageBufferSize=0;
 unsigned short *raw_thermal_image=new unsigned short[160*120];
 unsigned char *rgb_thermal_image=new unsigned char[160*120*4];
 for(n=0;n<160*120;n++)
 {
 raw_thermal_image[n]=128;
 rgb_thermal_image[n*4+0]=128;
 rgb_thermal_image[n*4+1]=128;
 rgb_thermal_image[n*4+2]=128;
 rgb_thermal_image[n*4+3]=0xff;
 }
 //   (164   )
 long min=0x10000;
 long max=0;
 for(y=0;y<120;y++) 
 {
 for(x=0;x<160;x++)
 { 
 long offset=(y*164+x)*2+28;
 if (x>=80) offset+=4;
 unsigned short value=*((unsigned short*)(ImageBuffer+offset));
 raw_thermal_image[x+y*160]=value;
 if (value<min) min=value;
 if (value>max) max=value;
 }
 }
 // 
 long delta=max-min;
 if (delta==0) delta=1;
 for(x=0;x<160;x++)
 {
 for(y=0;y<120;y++)
 {
 long offset=x+y*160;
 long value=raw_thermal_image[offset];
 value-=min;
 value=(value*255)/delta;
 offset=y+(159-x)*120;
 value&=0xff;
 rgb_thermal_image[offset*4+0]=ColorMap_B[value];
 rgb_thermal_image[offset*4+1]=ColorMap_G[value];
 rgb_thermal_image[offset*4+2]=ColorMap_R[value];
 rgb_thermal_image[offset*4+3]=0xff;
 }
 }
 // 
 AddLog("=====Save image!=====\r\n");
 char filename[255];
 sprintf(filename,"Image\\img%04i.tga",ImageIndex);
 SaveTGA(filename,120,160,rgb_thermal_image);
 delete[](rgb_thermal_image);
 delete[](raw_thermal_image);
 ImageIndex++;
 return(true);
}
//----------------------------------------------------------------------------------------------------
//   
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::LoadColorMap(char *filename)
{ 
 FILE *file=fopen(filename,"rb");
 if (file==NULL) return(false);
 unsigned char colormap[768];
 if (fread(colormap,sizeof(unsigned char),768,file)<768)
 {
 fclose(file);
 return(false);
 }
 fclose(file);
 for(long n=0;n<256;n++)
 {
 ColorMap_R[n]=colormap[n*3+0];
 ColorMap_G[n]=colormap[n*3+1];
 ColorMap_B[n]=colormap[n*3+2];
 }
 return(true);
}


//---------------------------------------------------------------------

