#ifndef CFLIRONECONTROL_H
#define CFLIRONECONTROL_H

#include "stdafx.h"
#include "tga.h"
#include <setupapi.h>
#include <basetyps.h>
#include <assert.h>

#define IMAGE_BUFFER_SIZE 1048576

//   
#define MAX_DEVPATH_LENGTH 256

//   iAP
//  Frame
#define IOCTL_FLIR_ONE_GEN2_FRAME_STOP		1
//  Frame
#define IOCTL_FLIR_ONE_GEN2_FRAME_START		2
//  FileIO
#define IOCTL_FLIR_ONE_GEN2_FILEIO_STOP		4
//  FileIO
#define IOCTL_FLIR_ONE_GEN2_FILEIO_START	8

//  Flir One
class CFlirOneControl
{
 protected:
  //- -------------------------------------------------------  
  HANDLE hFile_FileIO;// FileIO
  HANDLE hFile_Frame;// Frame
  HANDLE hFile_iAP;// iAP

  OVERLAPPED Overlapped_FileIO;//   FileIO
  OVERLAPPED Overlapped_Frame;//   Frame
  OVERLAPPED Overlapped_iAP;//   iAP

  bool Start_FileIO;
  bool Start_Frame;
  bool Start_iAP;

  char *Data;
  unsigned long SizeOfData;

  unsigned char *ImageBuffer;//     
  unsigned long ImageBufferSize;//     
  long ImageIndex;//  

  unsigned char ColorMap_R[256];//  
  unsigned char ColorMap_G[256];//  
  unsigned char ColorMap_B[256];//  
  //- ----------------------------------------------------------
  //-------------------------------------------------------------------
 public:
  //- ------------------------------------------------------
  CFlirOneControl(void);
  //- -------------------------------------------------------
  ~CFlirOneControl();
  //- -------------------------------------------------------
  //- ----------------------------------------------------------
  bool Open(void);//  
  void Close(void);//  
  bool Processing(void);//
  bool CreateImage(unsigned char *buffer,unsigned long size);// 
  bool LoadColorMap(char *filename);//   
  //-------------------------------------------------------------------
 protected:
  void AddLog(char *string);//   log-
  void AddLog(long value);//   log-
  bool GetDevicePath(IN LPGUID InterfaceGuid,PCHAR DevicePath,size_t BufLen);//   GUID

};

#endif
